function CustomMarkerLeaflet(point, map, args) {
  this.point = point;
  this.args = args;
  this.map = map;

  this.draw();
}

CustomMarkerLeaflet.prototype = L.marker();

CustomMarkerLeaflet.prototype.draw = function() {
  var self = this;
  var div = this.div;

  if (!div) {
    // create a custom icon
    var myIcon = L.divIcon({html: self.args.html, className: self.args.className})

    self.options.icon = myIcon;
    self.options.icon.options.iconUrl = '';
    self._latlng = L.latLng(this.map.layerPointToLatLng(this.point));
    // add icon to the map
    self.addTo(this.map);
    this.div = self._icon;
  }
};

CustomMarkerLeaflet.prototype.remove = function() {
  if (this.div) {
    this.div.parentNode.removeChild(this.div);
    this.div = null;
  }
};

CustomMarkerLeaflet.prototype.getPosition = function() {
  return this.point;
};
